<template>
    <div>
            <b-card
    title="แบบสอบถามวิเคราะห์ความเสี่ยงเป็นโรคซึมเศร้าเบื้องต้น"
    tag="article"
    style="max-width: 45rem;"
    class="mb-2"
    >
    <transition name="fade" mode="out-in">
        <div v-if="!showSent" :key="keyValue">
            <b-card-text>
            <strong>ข้อที่ {{ currentQuestion.id }}</strong> {{ currentQuestion.question }}
            </b-card-text>
            <b-form-group label="ระดับการเกิด">
                <b-form-radio-group id="radio-group-2" v-model="currentQuestion.answer" name="radio-sub-component">
            <span><b-form-radio name="some-radios" value="0">ไม่เคย</b-form-radio>
            <b-form-radio name="some-radios" value="1">บางครั้ง</b-form-radio>
            <b-form-radio name="some-radios" value="2">บ่อย</b-form-radio>
            <b-form-radio name="some-radios" value="3">ทุกวัน</b-form-radio></span>
            </b-form-radio-group>
            </b-form-group>
            <b-button variant="primary" @click="decrementIndex()">&lt; ข้อที่แล้ว</b-button>
            <b-button variant="primary" @click="incrementIndex()">ข้อถัดไป &gt;</b-button>
        </div>
        <div v-else>
             <hr/>
              <h4>คำตอบของท่านได้ถูกส่งไปเรียบร้อย</h4>
              <p>คลิกที่ปุ่มด้านล่างเพื่อรับผลการประเมิน</p>
              <nuxt-link to="/login"><b-button variant="primary">ไปที่หน้าหลัก</b-button></nuxt-link>
        </div>
    </transition>
  </b-card>
            </div>
</template>

<script>
export default {
    data: () => {
        return { currentSurveyIndex: 0, options: {
            everydaySelected: false,
            usuallySelected: false,
            sometimesSelected: false,
            neverSelected: false,
            keyValue: false
        }, showSent: false }
    },
    methods: {
        async incrementIndex() {
            if (this.currentSurveyIndex < this.questions.length - 1) {
                this.currentSurveyIndex++
                this.keyValue = !this.keyValue
            } else {
                this.showSent = true
                await this.postAnswersFromQuestion()
                
            }
        },
        decrementIndex() {
            if (this.currentSurveyIndex > 0) {
                this.currentSurveyIndex--
                this.keyValue = !this.keyValue
            }
        },
        checkAnswer(answer) {
            return currentQuestion.answer === answer
        },
        async postAnswersFromQuestion() {
            let answers = []
            for (let question of this.questions) {
                let answer = {
                    question_id: question.id,
                    answer: question.answer
                }
                answers.push(answer)
            }
            await this.$axios.post('/questions', {
                answers: answers
            })
        }
    },
    computed: {
        currentQuestion: function () {
            return this.questions[this.currentSurveyIndex]
        }
    },
    watch: {
        everydaySelected: () => {
            if (this.everydaySelected) {
                this.questions[this.currentSurveyIndex].answer = 4
            }
        },
        usuallySelected: () => {
            if (this.usuallySelected) {
                this.questions[this.currentSurveyIndex].answer = 3
            }
        },
        sometimesSelected: () => {
           if (this.sometimesSelected) {
                this.questions[this.currentSurveyIndex].answer = 2
            }
        },
        neverSelected: () => {
            if (this.neverSelected) {
                this.questions[this.currentSurveyIndex].answer = 1
            }
        }
    },
    async asyncData({ $axios }) {
        const { data } = await $axios.get('/questions')
        return { questions: data.questions }
    }
}
</script>

<style>
    .fade-enter-active, .fade-leave-active {
        transition: opacity .35s;
    }
    .fade-enter, .fade-leave-to /* .fade-leave-active below version 2.1.8 */ {
        opacity: 0;
    }
</style>
